unit gmp;
{
///////////////////////////////////////////////////////////////////////
GMP (GNU Multiple Precision Arithmetic Library)
Windows DLLp Delphijbg (based on gmp-4.1.3)
ÓI[h

  Delphicyggmp-3.dllgp邽߂̃jbgłB
  WindowsȊOł͍̓lĂ܂B
  Z𒆐SɈڐAłB錾ĂȂ֐}N܂B

  CZX̓IWî܂܂ł(GNU LGPL)
  ڐAɔoO\̂Ŏgۂ͒ӂĂB

programed by ł͂

2004/07/22 4.1.3-0.0 : ZƓo͂
2004/08/12 4.1.3-0.1 : overloadŃbpĂ֐̔
2004/08/13 4.1.3-0.2 : I[hɑΉ

///////////////////////////////////////////////////////////////////////

/* Definitions for GNU multiple precision functions.   -*- mode: c -*-

Copyright 1991, 1993, 1994, 1995, 1996, 1997, 1999, 2000, 2001, 2002, 2003,
2004 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA. */
}

interface

{
#define __GMP_BITS_PER_MP_LIMB             32
#define __GMP_HAVE_HOST_CPU_FAMILY_power   0
#define __GMP_HAVE_HOST_CPU_FAMILY_powerpc 0
#define GMP_LIMB_BITS                      32
#define GMP_NAIL_BITS                      0
}
const
  __GMP_BITS_PER_MP_LIMB = 32;
  __GMP_HAVE_HOST_CPU_FAMILY_power = 0;
  __GMP_HAVE_HOST_CPU_FAMILY_powerpc = 0;
  GMP_LIMB_BITS = 32;
  GMP_NAIL_BITS = 0;

{
#ifdef __GMP_SHORT_LIMB
typedef unsigned int		mp_limb_t;
typedef int			mp_limb_signed_t;
#else
#ifdef _LONG_LONG_LIMB
typedef unsigned long long int	mp_limb_t;
typedef long long int		mp_limb_signed_t;
#else
typedef unsigned long int	mp_limb_t;
typedef long int		mp_limb_signed_t;
#endif
#endif
}
type
  mp_limb_t = Cardinal;
  mp_limb_signed_t = Integer;

{
typedef mp_limb_t *		mp_ptr;
typedef __gmp_const mp_limb_t *	mp_srcptr;
#if defined (_CRAY) && ! defined (_CRAYMPP)
/* plain `int' is much faster (48 bits) */
#define __GMP_MP_SIZE_T_INT     1
typedef int			mp_size_t;
typedef int			mp_exp_t;
#else
#define __GMP_MP_SIZE_T_INT     0
typedef long int		mp_size_t;
typedef long int		mp_exp_t;
#endif
}
type
  mp_ptr = ^mp_limb_t;
//mp_srcptr ͌Ăяo錾constɂ
  mp_size_t = Integer;
  mp_exp_t = Integer;

(*
typedef struct
{
  int _mp_alloc;		/* Number of *limbs* allocated and pointed
				   to by the _mp_d field.  */
  int _mp_size;			/* abs(_mp_size) is the number of limbs the
				   last field points to.  If _mp_size is
				   negative this is a negative number.  */
  mp_limb_t *_mp_d;		/* Pointer to the limbs.  */
} __mpz_struct;

typedef __mpz_struct MP_INT;
typedef __mpz_struct mpz_t[1];

*)

type
  mpz_t = record
    _mp_alloc: Integer;
    _mp_size: Integer;
    _mp_d: mp_ptr;
  end;

  MP_INT = mpz_t;

(*
typedef struct
{
  __mpz_struct _mp_num;
  __mpz_struct _mp_den;
} __mpq_struct;

typedef __mpq_struct MP_RAT;
typedef __mpq_struct mpq_t[1];

*)

  mpq_t = record
    _mp_num: mpz_t;
    _mp_den: mpz_t;
  end;

  MP_RAT = mpq_t;

(*
typedef struct
{
  int _mp_prec;			/* Max precision, in number of `mp_limb_t's.
				   Set by mpf_init and modified by
				   mpf_set_prec.  The area pointed to by the
				   _mp_d field contains `prec' + 1 limbs.  */
  int _mp_size;			/* abs(_mp_size) is the number of limbs the
				   last field points to.  If _mp_size is
				   negative this is a negative number.  */
  mp_exp_t _mp_exp;		/* Exponent, in the base of `mp_limb_t'.  */
  mp_limb_t *_mp_d;		/* Pointer to the limbs.  */
} __mpf_struct;

/* typedef __mpf_struct MP_FLOAT; */
typedef __mpf_struct mpf_t[1];
*)

  mpf_t = record
    _mp_prec: Integer;
    _mp_size: Integer;
    _mp_exp: mp_exp_t;
    _mp_d: ^mp_limb_t;
  end;


(*
/* Available random number generation algorithms.  */
typedef enum
{
  GMP_RAND_ALG_DEFAULT = 0,
  GMP_RAND_ALG_LC = GMP_RAND_ALG_DEFAULT /* Linear congruential.  */
} gmp_randalg_t;
*)
  gmp_randalg_t = (GMP_RAND_ALG_DEFAULT = 0,GMP_RAND_ALG_LC = 0);

(*
/* Linear congruential data struct.  */
typedef struct {
  mpz_t _mp_a;			/* Multiplier. */
  unsigned long int _mp_c;	/* Adder. */
  mpz_t _mp_m;			/* Modulus (valid only if m2exp == 0).  */
  unsigned long int _mp_m2exp;	/* If != 0, modulus is 2 ^ m2exp.  */
} __gmp_randata_lc;
*)
  __gmp_randata_lc = record
    _mp_a: mpz_t;
    _mp_c: Cardinal;
    _mp_m: mpz_t;
    _mp_m2exp: Cardinal;
  end;

(*
/* Random state struct.  */
typedef struct
{
  mpz_t _mp_seed;		/* Current seed.  */
  gmp_randalg_t _mp_alg;	/* Algorithm used.  */
  union {			/* Algorithm specific data.  */
    __gmp_randata_lc *_mp_lc;	/* Linear congruential.  */
  } _mp_algdata;
} __gmp_randstate_struct;
typedef __gmp_randstate_struct gmp_randstate_t[1];
*)
  __gmp_randstate_alg_union = record
    _mp_lc: ^__gmp_randata_lc;
  end;

  gmp_randstate_t = record
    _mp_seed: mpz_t;
    _mp_alg: gmp_randalg_t;
    _mp_algdata: __gmp_randstate_alg_union;
  end;


(*
/* Types for function declarations in gmp files.  */
/* ??? Should not pollute user name space with these ??? */
typedef __gmp_const __mpz_struct *mpz_srcptr;
typedef __mpz_struct *mpz_ptr;
typedef __gmp_const __mpf_struct *mpf_srcptr;
typedef __mpf_struct *mpf_ptr;
typedef __gmp_const __mpq_struct *mpq_srcptr;
typedef __mpq_struct *mpq_ptr;
*)
  mpz_ptr = ^mpz_t;
  mpf_ptr = ^mpf_t;
  mpq_ptr = ^mpq_t;

{
5. Integer Functions
  ZȂ֐QBprefix: mpz_



  5.1 Initialization Functions
    ZȂ֐Q̓IyhĂ邱Ƃ肵ĂB
    ֐gpۂmpz_initpďĂȂ΂ȂȂB
    x΁AxłǂȒlłXgA邱ƂłB
}
procedure mpz_init(var int: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_init';
// intAl0ɃZbg

procedure mpz_init2(var int: mpz_t; n: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_init2';
// intn biẗ̗ďAl0ɃZbg
// n͗̈̏̒lŁǍ̉Zʂi[̂ɕKvł΁A
// int͎IɊgB
// ̊֐gp邱ƂɂAOɍőTCY킩ĂƂɁA
// ̂悤ȍĔzuhƂłB

procedure mpz_clear(var int: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_clear';
// int̎gpĂ̈JB
// mpz_t ϐ͕svɂȂ΂̊֐ĂяoĉȂĂ͂ȂȂB

procedure mpz_realloc2(var int: mpz_t; n: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_realloc2';
// int̊mۗ̈n bitɕύXB
// ύXA肫int̒l͕ێAłȂ0ɃZbgB
// ̊֐́AĔzuJԂ̂h߂ɕϐ̈傫A
// ̈kăq[vɃԋp̂ɎgpłB

procedure _mpz_array_init(int_array: mpz_ptr; array_size: Integer; fixed_num_bits: mp_size_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_array_init';
procedure mpz_array_init(int_array: mpz_ptr; array_size: Integer; fixed_num_bits: mp_size_t); overload;
procedure mpz_array_init(var int_array: array of mpz_t; fixed_num_bits: mp_size_t); overload;
// ̊֐͓ȏsB
// fixed_num_bits bit́uŒ蒷v̗̈Aint_arraŷꂼ̗vfɊmۂB
// ̊֐Ŋmۂ̈́Aʏmpz_initŊmۂ̈Ƃ͈ႢA
// gȂBvÓAgpǂȒlmۂ̂ɏ\ł
// ƂƂۏ؂ȂĂ͂ȂȂB
// iKvȗ̗̈ʂɊւĂ̓wv{QƁj
// ̊֐́Aȗ̈ʂɊmۂĔzu肷̂邱ƂɂA
// Ȕz񂪕KvȃASYŁA̎gpʂ}邱ƂłB
// ̊֐ɂAmۂꂽ̈Ji͂ȂB
// mpz_clearĂяoĂ͂ȂȂB
//
// overloadł̓I[vzp[^ɂ郉bp[łB

procedure _mpz_realloc(var int: mpz_t; n: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_realloc';
// mpz_realloc2ƓAԂl͏ɓKȂ̂ŁAjׂłB
// Ĕzuɂmpz_realloc2̕KłB
// VTCYlimbł鎞ȊOmpz_realloc2ƓB

{


  5.2 Assignment Functions
    ̊֐Q́Aς݂̗̈ɐVlZbg
}
procedure mpz_set(var rop: mpz_t; const op: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_set';
procedure mpz_set_ui(var rop: mpz_t; op: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_set_ui';
procedure mpz_set_si(var rop: mpz_t; op: Integer); cdecl; external 'cyggmp-3.dll' name '__gmpz_set_si';
procedure mpz_set_d(var rop: mpz_t; op: Double); cdecl; external 'cyggmp-3.dll' name '__gmpz_set_d';
procedure mpz_set_q(var rop: mpz_t; const op: mpq_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_set_q';
procedure mpz_set_f(var rop: mpz_t; const op: mpf_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_set_f';
// ropop̒lZbgB
// mpz_set_d,mpz_set_q,mpz_set_fop𐮐ɐ؂̂ĂB

function mpz_set_str(var rop: mpz_t; const str: PChar; base: Integer): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_set_str';
// ropɁAbaseinull-terminated̎lB
// white spacestrɌĂAׂďɖB
// base2-36LłB0ł鎞́Aȉ̋KŊ߂:
// '0x'or'0X'Ŏn܂16iAȊO'0'Ŏn܂8iA
// ȊO10i肳B
// ̊֐́AׂĂ̕baseiƂėLȐł0A
// łȂ-1ԂB

procedure mpz_swap(var rop1: mpz_t; var rop2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_swap';
// rop1rop2悭B

{


  5.3 Combined Initialization and Assignment Functions
    GMP͕ʌn̏Zbg֐QpӂĂB
    ̊֐Q́AƓɒlZbĝŁAmpz_init_set...
    ƂOłB
    mpz_init_set...֐Qŏ΁AZ֐souceƂĂ
    destinationƂĂgpłB
    ɏς݂̕ϐɑ΂āÅ֐QgĂ͂ȂȂB
}
procedure mpz_init_set(var rop: mpz_t; const op: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_init_set';
procedure mpz_init_set_ui(var rop: mpz_t; op: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_init_set_ui';
procedure mpz_init_set_si(var rop: mpz_t; op: Integer); cdecl; external 'cyggmp-3.dll' name '__gmpz_init_set_si';
procedure mpz_init_set_d(var rop: mpz_t; op: Double); cdecl; external 'cyggmp-3.dll' name '__gmpz_init_set_d';
// rop1 limbŏAop̐lZbg

function mpz_init_set_str(var rop: mpz_t; const str: PChar; base: Integer): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_init_set_str';
// ̈悪ȊOmpz_set_strƓ
// G[N-1Ԃꍇłrop͏Ă̂
// mpz_clearĂԕKv

{


  5.4 Conversion Functions
    GMP^AC̕W^ւ̕ϊ֐QłB
    GMP^ւ̕ϊɂĂSection 5.2[Assigning Integers],
    Section 5.12[I/O of Integers]Q
}
function mpz_get_ui(const op: mpz_t): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_get_ui';
// op̒lunsigned longŕԂ
// op傫́A܂肫ŉbitԂB
// ͖AΒlgB

function mpz_get_si(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_get_si';
// op̒lsigned longŕԂ
// op傫ꍇ́AopƓŁA܂肫ŉbitԂB
// opsigned longɎ܂Ȃ́AԂl͂܂ӖȂB
// ܂邩ǂmpz_fits_slong_p֐ŒׂB

function mpz_get_d(const op: mpz_t): Double; cdecl; external 'cyggmp-3.dll' name '__gmpz_get_d';
// opdoubleɕϊ

function mpz_get_d_2exp(var exp: Integer; const op: mpz_t): Double; cdecl; external 'cyggmp-3.dll' name '__gmpz_get_d_2exp';
// d*2^exp (0.5<|d|<1) Ȃop̂悢ߎld,exp߂

function _mpz_get_str(str: PChar; base: Integer; const op: mpz_t): PChar; cdecl; external 'cyggmp-3.dll' name '__gmpz_get_str'; overload;
function mpz_get_str(str: PChar; base: Integer; const op: mpz_t): PChar; overload;
function mpz_get_str(const op: mpz_t; base: Integer): String; overload;
// opbasei̐lɕϊBbase2-36LłB
// strNULLłΌ݂allocation֐ŕ̈悪mۂB
// ̗ʂstrlen(str)+1łA傤Ǖƃk^[~l[^̕łB
// strNULLłȂ΁Ampz_sizeinbase(op,base)+2\̗̈w
// Ȃ΂ȂȂB+2͕ƃ^[~l[^̕łB
// ԂĺA֐Ŋmۂ^ɂ炸Aʕւ̃|C^łB
//
// AP[g֐̂܂܂strnilČŊmۂƁA
// Delphi͉łAMSVCRT.dllłȂƉłȂ̂Œ
//
// overloadł́Astringɂ郉bp[łB

function mpz_getlimbn(const op: mpz_t; n: mp_size_t): mp_limb_t; cdecl; external 'cyggmp-3.dll' name '__gmpz_getlimbn';
// opnԖڂlimbԂB͖AΒl݂̂gB
// mpz_size֐gpƁAopɂlimb邩𒲂ׂB
// n0mpz_size(op)-1͈̔͂ɂȂƁÅ֐0ԂB

{


  5.5 Arithmetic Functions
}
procedure mpz_add(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_add';
procedure mpz_add_ui(var rop: mpz_t; const op1: mpz_t; op2: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_add_ui';
// ropop1+op2Zbg

procedure mpz_sub(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_sub';
procedure mpz_sub_ui(var rop: mpz_t; const op1: mpz_t; op2: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_sub_ui';
procedure mpz_ui_sub(var rop: mpz_t; op1: Cardinal; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_ui_sub';
// ropop1-op2Zbg

procedure mpz_mul(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_mul';
procedure mpz_mul_ui(var rop: mpz_t; const op1: mpz_t; op2: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_mul_ui';
procedure mpz_mul_si(var rop: mpz_t; const op1: mpz_t; op2: Integer); cdecl; external 'cyggmp-3.dll' name '__gmpz_mul_si';
// ropop1*op2Zbg

procedure mpz_addmul(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_addmul';
procedure mpz_addmul_ui(var rop: mpz_t; const op1: mpz_t; op2: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_addmul_ui';
// roprop+op1*op2Zbg

procedure mpz_submul(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_submul';
procedure mpz_submul_ui(var rop: mpz_t; const op1: mpz_t; op2: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_submul_ui';
// roprop-op1*op2Zbg

procedure mpz_mul_2exp(var rop: mpz_t; const op1: mpz_t; op2: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_mul_2exp';
// ropop1*2^op2Zbg
// ̑́Aop2 bitVtĝƓłB

procedure mpz_neg(var rop: mpz_t; const op: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_neg';
// rop-opZbg

procedure mpz_abs(var rop: mpz_t; const op: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_abs';
// ropop̐ΒlZbg

{


  5.6 Division Functions
    division͏0ł鎞ɂĂ͖`łB
    division,modulo֐(ݏ]֐mpz_pown,mpz_pown_ui܂)ɏ0
    ^ƁA0ɂ鏜ZӐ}IɔB
    ɂAvO͒ʏC̐vZƓ悤ɁAZpO󂯎
    ƂłB
}
procedure mpz_cdiv_q(var q: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_q';
procedure mpz_cdiv_r(var r: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_r';
procedure mpz_cdiv_qr(var q: mpz_t; var r: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_qr';
function mpz_cdiv_q_ui(var q: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_q_ui';
function mpz_cdiv_r_ui(var r: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_r_ui';
function mpz_cdiv_qr_ui(var q: mpz_t; var r: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_qr_ui';
function mpz_cdiv_ui(const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_ui';
procedure mpz_cdiv_q_2exp(var q: mpz_t; const n: mpz_t; b: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_q_2exp';
procedure mpz_cdiv_r_2exp(var r: mpz_t; const n: mpz_t; b: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_cdiv_r_2exp';
  //cdivńAq{֊ۂ߁Ar̕dƔ΂ɎB"ceil"
procedure mpz_fdiv_q(var q: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_q';
procedure mpz_fdiv_r(var r: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_r';
procedure mpz_fdiv_qr(var q: mpz_t; var r: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_qr';
function mpz_fdiv_q_ui(var q: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_q_ui';
function mpz_fdiv_r_ui(var r: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_r_ui';
function mpz_fdiv_qr_ui(var q: mpz_t; var r: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_qr_ui';
function mpz_fdiv_ui(const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_ui';
procedure mpz_fdiv_q_2exp(var q: mpz_t; const n: mpz_t; b: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_q_2exp';
procedure mpz_fdiv_r_2exp(var r: mpz_t; const n: mpz_t; b: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_r_2exp';
  //fdivńAq|֊ۂ߁Ar̕dƓɎB"floor"
procedure mpz_tdiv_q(var q: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_q';
procedure mpz_tdiv_r(var r: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_r';
procedure mpz_tdiv_qr(var q: mpz_t; var r: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_qr';
function mpz_tdiv_q_ui(var q: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_q_ui';
function mpz_tdiv_r_ui(var r: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_r_ui';
function mpz_tdiv_qr_ui(var q: mpz_t; var r: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_qr_ui';
function mpz_tdiv_ui(const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_ui';
procedure mpz_tdiv_q_2exp(var q: mpz_t; const n: mpz_t; b: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_q_2exp';
procedure mpz_tdiv_r_2exp(var r: mpz_t; const n: mpz_t; b: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_tdiv_r_2exp';
  //tdivńAq0ɌĊۂ߁Ar̕nƓɎB"truncate"

//  ̊֐Qׂ͂āAndŊAq(and/or)]r𓾂B
// 2exp֐ɂĂd=2^bƂB
//  ۂ߂́̕AL̂ƂAcdiv̖Afdiv̖
// tdiv[łB
//  炷ׂĂ̊֐ɂāAn=qd+r A 0<=|r|<|d|A𖞂B
//  qn֐͏̂݁Arn֐͗]̂݁Aqrn֐͗vZB
// AAqrn֐̈ƂāAq,rɓϐnĂ͂ȂȂB
// nꍇAʂ͗\łȂB
//  uin֐̕ԂĺAׂĂdiv_ui֐ŗ]łB
// tdivcdivɂẮA]肪ɂȂ邱Ƃ邪ÂƂ̕Ԃl
// ]̐ΒlƂȂB
//  2expn֐͉EVtgƃrbg}XNAۂ߂ɊւĂ͑̂̂ƓlłB
// nɑ΂Ămpz_tdiv_q_2expmpz_fdiv_q_2expPȂErbgVtgłB
// nɑ΂ẮAmpz_fdiv_q_2exp͘_rbgZ֐Ȃ̂Ɠ
// n2̕␔ƂĂ̎ZprbgVtgłAɑ΂mpz_tdiv_q_2exp
// n𕄍ƐΒlɕĈB
// ()mpz_fdiv_q_2exp: n2̕␔\ƂĎZpErbgVtg
//       mpz_tdiv_q_2exp: n𕄍Ɛlɕ܂܁AErbgVtg

procedure mpz_mod(var r: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_mod';
function mpz_mod_ui(var r: mpz_t; const n: mpz_t; d: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_fdiv_r_ui';
//  r n mod d ZbgBd͖̕B
// ʂ͏ɔ񕉂łB
//  mpz_mod_uíAmpz_fdiv_r_ui̕ʖłA]rɃZbgƂƂɁA
// ԂlƂĕԂBԂl݂̂~́Ampz_fdiv_uiQƁB

procedure mpz_divexact(var q: mpz_t; const n: mpz_t; const d: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_divexact';
procedure mpz_divexact_ui(var q: mpz_t; const n: mpz_t; d: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_divexact_ui';
//  q n/d ZbgB̊֐́AOdn؂邱Ƃ
// 킩Ă鎞̂݁AʂԂB
//  ̊֐́ȀZ֐葬BL񕪐ɂ鎞Ȃǂ́A
// 傤Ǌ؂邱Ƃ킩Ă鎞́Aŗǂ̕@łB

function mpz_divisible_p(const n: mpz_t; const d: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_divisible_p';
function mpz_divisible_ui_p(const n: mpz_t; d: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_divisible_ui_p';
function mpz_divisible_2exp_p(const n: mpz_t; b: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_divisible_2exp_p';
//  ndł傤Ǌ؂鎞ɔ0ԂB
// AAmpz_dividible_2exp_p̏ꍇ́An2^dł傤Ǌ؂鎞łB

function mpz_congruent_p(const n: mpz_t; const c: mpz_t; const d: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_congruent_p';
function mpz_congruent_ui_p(const n: mpz_t; c: Cardinal; d: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_congruent_ui_p';
function mpz_congruent_2exp_p(const n: mpz_t; const c: mpz_t; b: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_congruent_2exp_p';
//  nAd@ƂcƈvicdŊ]ƁAndŊ]肪vj
// 0ԂB
// AAmpz_congruent_2exp_p̏ꍇ́A@2^bƂB

{


  5.7 Exponentiation Functions
}
procedure mpz_powm(var rop: mpz_t; const base: mpz_t; const exp: mpz_t; const m: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_powm';
procedure mpz_powm_ui(var rop: mpz_t; const base: mpz_t; exp: Cardinal; const m: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_powm_ui';
//  rop base^exp mod m ZbgB
//  t(base^(-1) mod m)݂鎞(Section 5.9 mpz_invert Q)
// expwłBexpw肳Ă鎞ɁAt݂Ȃ΁A
// 0ɂ鏜ZB

procedure mpz_pow_ui(var rop: mpz_t; const base: mpz_t; exp: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_pow_ui';
procedure mpz_ui_pow_ui(var rop: mpz_t; base: Cardinal; exp: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_ui_pow_ui';
//  rop base^expZbgB
//  AA0^01ƂȂB

{


  5.8 Root Extraction Funtions
}
function mpz_root(var rop: mpz_t; const op: mpz_t; n: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_root';
// ropɁAopn捪̐ZbgB
// opropnł΁A0ԂB

procedure mpz_sqrt(var rop: mpz_t; const op: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_sqrt';
// rop op̃[g(2捪)̐ZbgB

procedure mpz_sqrtrem(var rop1: mpz_t; var rop2: mpz_t; const op: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_sqrtrem';
//  rop1 op̃[g̐Arop2 c](op - rop1^2)ZbgB
// opSł΁Ac]rop20ƂȂB
//  rop1rop2ɓϐw肳ꂽ́Aʂ͖`łB

function mpz_perfect_power_p(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_perfect_power_p';
//  op"perfect power"łΔ0ԂB
// "perfect power"łƂ́A鐮a,b b>1 ݂āAop = a^b
// ł邱ƂB
//  ̒`ɂƁA01͂ǂ"perfect power"Ƃ݂ȂB
// op^邱Ƃ͂ł邪AA݂̂"perfect power"
// ̉\͂ȂB

function mpz_perfect_square_p(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_perfect_square_p';
//  opSAȂ킿Aop̕ł鎞A0ԂB
// ̒`ɂƁA01͂ǂSƂ݂ȂB

{


  5.9 Number Theoretic Functions
}
function mpz_probab_prime_p(const n: mpz_t; reps: Integer): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_probab_prime_p';
//  nfł邩ǂ𔻒肷B
// nmɑfł鎞2A炭fł鎞(ł邱Ƃ܂)1A
// łƂ0ԂB
//  ̊֐́AAMiller-RabinfeXgJԂB
// rep͉JԂŁA5-10KłB𑝂₷ƂɂA
// āu炭fvƕԂm邱ƂłB
//  Miller-Rabinѓl̃eXg͐mɂ͍eXgłB
// eXgɃpXȂ͍łƂ킩邪ApX͑fȂA
// ȂBɏ̍eXgɃpXȂ̂ŁA
// 䂦ɁApX͂炭fƂ݂ȂƂłB
//
// ()Miller-RabinfeXg1/4̊mŌč[fł
//  肷B̊֐́A_ɒƂeXgJԂB
//  5JԂ(1/4)^5=0.0009765625A0.1%Ĕ肷邱ƂƂȂB

procedure mpz_nextprime(var rop: mpz_t; const op: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_nextprime';
//  rop op傫̑fZbg
//  ̊֐́Af̔ɊmASYgpB
// ́ApړIɂ͏\Kł邪AĔ肷m
// 킸cB

procedure mpz_gcd(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_gcd';
//  rop op1op2̍ő񐔂ZbgB
// Iyh̕Е܂͗łƂĂAʂ͏ɐłB

function mpz_gcd_ui(var rop: mpz_t; const op1: mpz_t; op2: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_gcd_ui';
//  op1op2̍ő񐔂vZBropNULLłȂ΁A
// ʂropɓB
//  Aʂunsigned long int(Cardinal)ɓ肫̂ł΁A
// ʂ͕ԂlƂĕԂB肫Ȃ΁AԂl0ƂȂA
// ʂop1ɓB
// op20łȂ΁Aʂ͏ɓ肫B

procedure mpz_gcdext(var g: mpz_t;var s: mpz_t;var t: mpz_t;const a: mpz_t;const b: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_gcdext';
//  g ab̍ő񐔂Aas + bt = g 𖞂Ws,t ɃZbgB
// a,b̕Е͗łĂAg͏ɐłB
//  AtNULLȂ΁A̒l͌vZȂB

procedure mpz_lcm(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_lcm';
procedure mpz_lcm_ui(var rop: mpz_t; const op1: mpz_t; op2: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_lcm_ui';
//  rop op1op2̍ŏ{ZbgB
// op1op2̕ɂȂArop͏ɐłB
// op1op2̂ǂ炩0łrop0ɂȂB

function mpz_invert(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_invert';
//  @op2̉łop1̋tvZAʂropɓB
// t݂ΕԂl͔0ŁArop 0 <= rop < op2 𖞂B
// t݂Ȃ΁AԂl0rop͖`ƂȂB

function mpz_jacobi(const a: mpz_t; const b: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_jacobi';
//  Jacobi(Rr)L (a/b) vZBbł̂ݒ`ĂB

function mpz_legendre(const a: mpz_t; const p: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_jacobi';
//  Legendre(WFh)L (a/p) vZBpfł̂
// `ĂB̂悤pɑ΂āAJacobiLƓłB
//
// ̊֐mpz_jacobi̕ʖłB

function mpz_kronecker(const a: mpz_t; const b: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_jacobi';
function mpz_kronecker_si(const a: mpz_t; b: Integer): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_kronecker_si';
function mpz_kronecker_ui(const a: mpz_t; b: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_kronecker_ui';
function mpz_si_kronecker(a: Integer; const b: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_si_kronecker';
function mpz_ui_kronecker(a: Cardinal; const b: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_ui_kronecker';
//  Jacobi(Rr)L (a/b) Kronecker(NlbJ[)gA
// a̂Ƃ(a/2)=(2/a),a̎(a/2)=0 pČvZB
//  b̂Ƃ́AJacobiLKroneckerLƓłB
// ̂߁Ampz_kronecker_uiȂǂ̊֐́Ǎ^̈ႤJacobiLƂĂ
// gp邱ƂłB
//
// mpz_kroneckermpz_jacobi̕ʖłB

function mpz_remove(var rop: mpz_t; const op: mpz_t; const f: mpz_t): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_remove';
//  opqfׂĂ͂炢AʂropɃXgABԂl͂̈q
// ͂ꂽłB

procedure mpz_fac_ui(var rop: mpz_t; op: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_fac_ui';
//  rop op! (op̊K)ZbgB

procedure mpz_bin_ui(var rop: mpz_t; const n: mpz_t; k: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_bin_ui';
procedure mpz_bin_uiui(var rop: mpz_t; n: Cardinal; k: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_bin_uiui';
//  񍀌W(binomial coefficient) (n,k)vZʂropɃXgAB
// mpz_bim_uiŁAnɕ̒l͋A(-n,k) = (-1)^k (n+k-1,k)gB
// Knuth volume 1 section 1.2.6 part G QƁB

procedure mpz_fib_ui(var fn: mpz_t; n: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_fib_ui';
procedure mpz_fib2_ui(var fn: mpz_t; var fnsub1: mpz_t; n: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_fib2_ui';
// mpz_fib_uíAfnnԖڂFibonacci Fn ZbgB
// mpz_fib2_uíAfnɂenAfnsub1ɂen-1ZbgB
//  ̊֐́AƗFibonaccivZ邽߂ɐ݌vĂB
// Al~́Ampz_fib2_uiŎn߂āA`en+1=en+en-1JԂ
// Ȃǂ̕@xXgłB

procedure mpz_lucnum_ui(var ln: mpz_t; n: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_lucnum_ui';
procedure mpz_lucnum2_ui(var ln: mpz_t; var lnsub1: mpz_t; n: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_lucnum2_ui';
// mpz_lucnum_uilnnԖڂLucas knZbgB
// mpz_lucnum2_uilnɂknAlnsub1ɂkn-1ZbgB
//  ̊֐́AƗLucasvZ邽߂ɐ݌vĂB
// Al~́Ampz_lucnum2_uiŎn߂āA`kn+1=kn+kn-1JԂ
// Ȃǂ̕@xXgłB

//  FibonacciLucas͊֘Ał̂ŁAmpz_fib2_uimpz_lucnum2_ui
// ĂԕKv͂܂ȂBFibonacciLucasւ̕ϊSection 16.7.4
// [Lucas Numbers Algorithm]ɂA̋teՂłB

{


  5.10 Comparison Functions
}
function mpz_cmp(const op1: mpz_t; const op2: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_cmp';
function mpz_cmp_d(const op1: mpz_t; op2: Double): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_cmp_d';
function mpz_cmp_si(const op1: mpz_t; op2: Integer): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_cmp_si';
function mpz_cmp_ui(const op1: mpz_t; op2: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_cmp_ui';
// op1op2rAop1>op2̂ƂAop1=op2̂Ƃ0Aop1<op2̂ƂԂ

function mpz_cmpabs(const op1: mpz_t; const op2: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_cmpabs';
function mpz_cmpabs_d(const op1: mpz_t; op2: Double): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_cmpabs_d';
function mpz_cmpabs_ui(const op1: mpz_t; op2: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_cmpabs_ui';
//  op1op2̐ΒlrA|op1|>|op2|̂ƂA|op1|=|op2|̂Ƃ0A
// |op1|<|op2|̂ƂԂ

function mpz_sgn(const op: mpz_t): Integer;
//  op>0̂Ƃ+1Aop=0̂Ƃ0Aop<0̂Ƃ-1ԂB
//  ̊֐̓IWi̓}NŎĂB

{


  5.11 Logical and Bit Manipulation Functions
    ȉ̊֐2̕␔ZpgpĂ悤ɂӂ܂B
    (ۂ͕̎ƐΒlĂ)
    ŉʃrbgbit 0 łB
}
procedure mpz_and(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_and';
// and
procedure mpz_ior(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_ior';
// inclusive-or
procedure mpz_xor(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_xor';
procedure mpz_eor(var rop: mpz_t; const op1: mpz_t; const op2: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_xor';
// exclusive-or
// op1op2Ƃ̃rbgZʂropɃZbg

procedure mpz_com(var rop: mpz_t; const op: mpz_t); cdecl; external 'cyggmp-3.dll' name '__gmpz_com';
// op1̕␔\(Srbg])ropɃZbg

function mpz_popcount(const op: mpz_t): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_popcount';
// op>=0̂Ƃ́Aop̃oCi\Lł1̗Ăbit(population count)ԂB
// op<0̂Ƃ́A1͖̐ƂȂ̂ŁAunsigned long(Cardinal)̍ől
// ԂB

function mpz_hamdist(const op1: mpz_t; const op2: mpz_t): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_hamdist';
//  op1op2>=0ł邩<0łƂA2̃Iyh̃n~OԂB
// n~O(hamming distance)́AbitƂop1op2قȂlƂbit̐łB
//  ǂ炩>=0łЕ<0łƂ́AقȂbit͖̐ƂȂ̂ŁA
// Ԃlunsigned long(Cardinal)̍őlƂȂB

function mpz_scan0(const op: mpz_t; starting_bit: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_scan0';
function mpz_scan1(const op: mpz_t; starting_bit: Cardinal): Cardinal; cdecl; external 'cyggmp-3.dll' name '__gmpz_scan1';
//  opAstarting_bitn߂āAbitɌāAŏ0 or 1łbit
// ܂ŃXLBԂl͌bit̃CfbNXłB
//  starting_bit̂TbitłƂ́Astarting_bitԂB
//  ̂悤bitȂƂULONG_MAX(unsigned long̍ől)
// ԂB́Ampz_scan0̐̒[߂ƂA܂́A
// mpz_scan1̐̒[߂ƂɔB

procedure mpz_setbit(var rop: mpz_t; bit_index: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_setbit';
// ropbit_index bit𗧂Ă

procedure mpz_clrbit(var rop: mpz_t; bit_index: Cardinal); cdecl; external 'cyggmp-3.dll' name '__gmpz_clrbit';
// ropbit_index bit

function mpz_tstbit(const op: mpz_t; bit_index: Cardinal): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_tstbit';
// opbit_index biteXgǍ 01 ԂB

{


  5.12 Input and Output Functions

    (ڐAҒ)section̊֐QFILE\̂̈ڐAł邽
     錾ĂȂ
}

{


  5.13 Random Number Functions

// ۗ

}

{


  5.14 Integer Import and Export
    ȉ̊֐ɂAmpz_tϐ͎RȃoCif[^(/)ϊł
}
procedure mpz_import(var rop: mpz_t; count, order, size, endian, nails: Integer; const op); cdecl; external 'cyggmp-3.dll' name '__gmpz_import';
//  ropop̔zf[^Zbg
//  p[^̓f[^̃tH[}bgw肷B
//
// size: ꂼ̔zvfbyte
// count: zvf̐
// order: =(1,-1), z̃GfBAw
//  1 =ŏʗvfz̍ŏɃXgAĂ
//  -1=ŉʗvfz̍ŏɃXgAĂ
// endian: =(1,-1,0), zvf̒ł̃GfBAw
//  1 =ŏbyteŏɗ(rbOGfBA)
//  -1=ŉbyteŏɗ(gGfBA)
//  0 =CPŨGfBAɏ]
// nails: ꂼ̔zvf̒ōŏnails bit͎̂Ă
//  0w肷Ɣzvf͑Sbitgp
//
//  f[^ɂ͕͊܂܂ĂȂ̂ŁArop͐̐ɂȂB
// vO͕Kv΁Ampz_negȂǂpĎŕZbgȂĂ
// ȂȂB
//  opɃACg͂ȂAǂȃAhXłB
//
// ()͏ȗBp[^͉ӏɕύXB

function mpz_export(var rop; var countp: Integer; order, size, endian, nails: Integer; const op: mpz_t): Pointer; cdecl; external 'cyggmp-3.dll' name '__gmpz_export';
//  opzf[^ɕϊropɏ
//  ()Ȃp[^mpz_importƓӖłB
//  ϊꂽzvf̐*countpɏ܂邪AcountpNULLw肷
// vf͎̂ĂB
// ropɂ̓f[^ނ̂ɏ\ȗ̈悪KvłBropNULLw肷
// ʂ̔źA݂GMPAP[g֐gĕKvȗ̈mۂĂ
// ܂B̈^ꂽmۂɂ炸AԂl͌ʂւ
// |C^łB
//  op0ł΁Aŏʔzvf͔0łBop0ł΁Acount0Ԃ
// ropɂ͉܂ȂB̂ƂAropNULLł΁Ä͊mۂꂸA
// NULLԂB
//  ͖AΒlGNX|[gBvO͕Kv΁A
// mpz_sgng擾Ȃ΂ȂȂB
//  opɃACg͂ȂAǂȃAhXłB
//  vOgŗ̈mۂƂ́Aȉ̎ŕKvȗ̈vZłB
//   numb = 8*size - nail;
//   count = (mpz_sizeinbase(z,2) + numb-1) / numb;
//   p = malloc(count*size);
//  ŁAz0łΖ{͕͗̈Kvł͂ȂAmpz_sizeinbase͏1ȏ
// Ԃ߁Acount1ȏɂȂBmalloc(0)Ŗ肪邱Ƃ邱
// ł邽߂łB

{
  5.15 Miscellaneous Functions

}
function mpz_fits_ulong_p(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_fits_ulong_p';
function mpz_fits_slong_p(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_fits_slong_p';
function mpz_fits_uint_p(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_fits_uint_p';
function mpz_fits_sint_p(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_fits_sint_p';
function mpz_fits_ushort_p(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_fits_ushort_p';
function mpz_fits_sshort_p(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_fits_sshort_p';
// ̂op܂肫Δ0AȂ0Ԃ

function mpz_odd_p(const op: mpz_t): Boolean;
function mpz_even_p(const op: mpz_t): Boolean;
// op𔻒肷B
// ̊֐̓IWił̓}NłB

function mpz_size(const op: mpz_t): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_size';
// oplimb̐ԂBop0̎0

function mpz_sizeinbase(const op: mpz_t; base: Integer): Integer; cdecl; external 'cyggmp-3.dll' name '__gmpz_sizeinbase';
//  opbasei\L̃TCYԂBbase2-36LłB
// ͖AΒlgpB
// ʂ͂傤ǂA1傫ȂB
// base2̗ݏłȂAʂ͂B
// op0łȂA1ԂB
//  ̊֐́Aop𕶎ɂ鎞ɕKvȗ̈m̂ɎgƂłB
// ʏAKvȗ̈́Å֐̕Ԃl2傫B
// null-terminator̕łB
//  mpz_sizeinbase(op,2)́A1琔Ĉԑ傫Ărbg̏ꏊ
// m̂ɎgpłB(bitwise֐0琔)


{


  10 Formatted Output

    10.1 Format Strings
      ȉڍׂ̓wvQƁj

    10.2 Functions
      ̊֐Q́AΉC̊֐ƓlłB
      񂪕słAψϊwqƈvȂꍇ
      ͗\s\ł邱ƂĂB

      (ڐAҒ)
      vprintfn̊֐́Aψ̍\DelphiƈقȂ̂Ő錾ĂȂB
      fprintf,asprintf,obstack_printfɂĂڐAł邽
      錾ĂȂB

      ψGMP\̂ńA|C^nƁB
      ̂܂܎w肷ƁAlnɂȂ蓮삵ȂB

      ^ȂI[vp[^ł̓bp[ł邪ADelphigcč^̌݊
      C邱ƁB
      64bit^ɂ͑ΉĂȂB
      _^Extended->Double̕ϊsAdoublêݑΉĂB
      string^Ƃ̓k^[~l[gĂяoŕۏ؂邱ƁB
}
function _gmp_printf(const fmt: PChar): Integer; cdecl; varargs; external 'cyggmp-3.dll' name '__gmp_printf';
function gmp_printf(const fmt: String; const Args: array of const): Integer;
// Wo͂ɏo͂BԂĺAG[-1AIŏ񂾕B
// Delphił̓R\[ȂvOł͖łB
//
// ψcdeclĂяołł͕_^doubleł̂ŒӁB
// I[vp[^bp[łł͕_^ExtendeddoubleɗƂĂB

function _gmp_sprintf(buf: PChar; const fmt: PChar): Integer; cdecl; varargs; external 'cyggmp-3.dll' name '__gmp_sprintf';
function gmp_sprintf(buf: PChar; const fmt: String; const Args: array of const): Integer;
//  nullIbufɏo͂BԂlnull񂾕B
//  buffmẗ̗悪dȂ邱Ƃ͋ĂȂB
//  ̊֐́Abuf̊mۗ̈zďނ̂hiȂ߁A
// ȂB
//
// ψcdeclĂяołł͕_^doubleł̂ŒӁB
// I[vp[^bp[łł͕_^ExtendeddoubleɗƂĂB

function _gmp_snprintf(buf: PChar; size: Integer; const fmt: PChar): Integer; cdecl; varargs; external 'cyggmp-3.dll' name '__gmp_snprintf';
function gmp_snprintf(buf: PChar; size: Integer; const fmt: String; const Args: array of const): Integer; overload;
function gmp_snprintf(var buf: String; const fmt: String; const Args: array of const): Integer; overload;
//  nullIbufɏo͂Bsize𒴂ď܂邱Ƃ͂ȂB
// o͑Ŝ󂯎ɂ́Anull-terminatorނ̂ɏ\
// 傫sizeɎw肵Ȃ΂ȂȂB
//  ԂĺAnull(͂)̕łB
// Aresult>=sizełȂ΁Aۂ̏o͂size-1̏o͂null
// ؂̂ĂĂB
//  buffmẗ̗悪dȂ邱Ƃ͋ĂȂB
//  ԂlISO C99 snprintf`łBC libraryvsprintfÂGLIBC 2.0.x
// ƂĂƂĂA͕ςȂB
//
//  ψcdeclĂяołł͕_^doubleł̂ŒӁB
//  I[vp[^bp[łł͕_^ExtendeddoubleɗƂĂB
//  stringł͌ĂяoSetLengthŊmۂꂽ̈o͗̈ƂB
// o͂buf菬ΎIɗ̈̓g~OB

{


  10 Formatted Input

    10.1 Formatted Input Strings
      ȉڍׂ̓wvQƁj

    10.2 Formatted Input Functions
      ̊֐Q́AΉC̊֐ƓlłB
      񂪕słAψϊwqƈvȂꍇ
      ͗\s\ł邱ƂĂB
      ƕϊʂ̏o͕ϐQƂ̗̈悪dȂ邱Ƃ͔F߂ĂȂB

      (ڐAҒ)
      vprintfn̊֐́Aψ̍\DelphiƈقȂ̂Ő錾ĂȂB
      fprintf,ɂĂڐAł邽
      錾ĂȂB

      ψGMP\̂ńA|C^nƁB
      ̂܂܎w肷ƁAlnɂȂ蓮삵ȂB
}
function _gmp_scanf(const fmt: PChar): Integer; cdecl; varargs; external 'cyggmp-3.dll' name '__gmp_scanf';
function gmp_scanf(const fmt: String; const Args: array of Pointer): Integer;
// W͂ǂ

function _gmp_sscanf(const s: PChar; const fmt: PChar): Integer; cdecl; varargs; external 'cyggmp-3.dll' name '__gmp_sscanf';
function gmp_sscanf(const s: String; const fmt: String; const Args: array of Pointer): Integer;
// sɎw肳ꂽnullI񂩂ǂ

//  ̊֐̕ԂĺAWC99 scanfƓAɉ߂XgAꂽ
// tB[h̐łB'%n'Ŏw肵tB[hƁA'*'ɂ͗}
// tB[h́AԂl̃JEgɓȂB
//  ȑO̔͗}tB[h1}b`ĂȂԂŁA
// }b`ׂtB[ĥɁAt@C̏I,t@CG[,̏I
// ̂ꂩɑꍇ́AԂl0ł͂ȂEOFԂB
// 񒆂̃e'%n'ȊÕtB[h̓}b`vB
// 񒆂whitespase͔CӈvłȂǍ`EOF͔ȂB
// swhitespaséAǂݍŔjA}b`̐ɓȂB
//
//  I[vp[^ł̓bp[łB
// string̃AhXnƂSetLengthȂǂŊmۂĂƁB





function mpf_sgn(const op: mpf_t): Integer;
function mpq_sgn(const op: mpq_t): Integer;

(*
enum
{
  GMP_ERROR_NONE = 0,
  GMP_ERROR_UNSUPPORTED_ARGUMENT = 1,
  GMP_ERROR_DIVISION_BY_ZERO = 2,
  GMP_ERROR_SQRT_OF_NEGATIVE = 4,
  GMP_ERROR_INVALID_ARGUMENT = 8,
  GMP_ERROR_ALLOCATE = 16,
  GMP_ERROR_BAD_STRING = 32,
  GMP_ERROR_UNUSED_ERROR
};

/* Major version number is the value of __GNU_MP__ too, above and in mp.h. */
#define __GNU_MP_VERSION 4
#define __GNU_MP_VERSION_MINOR 1
#define __GNU_MP_VERSION_PATCHLEVEL 3

#define __GMP_H__
#endif /* __GMP_H__ */
*)
const
  __GNU_MP_VERSION = 4;
  __GNU_MP_VERSION_MINOR = 1;
  __GNU_MP_VERSION_PATCHLEVEL = 3;
  

implementation

uses
  SysUtils;

procedure mpz_array_init(int_array: mpz_ptr; array_size: Integer; fixed_num_bits: mp_size_t); overload;
begin
    _mpz_array_init(int_array,array_size,fixed_num_bits);
end;

procedure mpz_array_init(var int_array: array of mpz_t; fixed_num_bits: mp_size_t); overload;
var
  size: Integer;
begin
    size := length(int_array);
    if size <> 0 then
      _mpz_array_init(mpz_ptr(@int_array[0]),size,fixed_num_bits);
end;

function mpz_get_str(str: PChar; base: Integer; const op: mpz_t): PChar; overload;
begin
    Result := _mpz_get_str(str,base,op);
end;

function mpz_get_str(const op: mpz_t; base: Integer): String; overload;
begin
    SetLength(Result, mpz_sizeinbase(op,base)+2);
    _mpz_get_str(@Result[1],base,op);
    SetLength(Result,strlen(PChar(Result)));
end;


function gmp_printf(const fmt: String; const Args: array of const): Integer;
var
  Argc: Integer;
begin
    Argc := length(Args);
    asm
      push  edi
      mov   ecx,Argc;
      test  ecx,ecx;
      jz    @call_original;
     @push_loop:
      mov   edx,Args;
      dec   ecx;
      lea   edi,[edx+ecx*8];
      xor   eax,eax;
      mov   al,TVarRec[edi].VType;
      cmp   eax,vtExtended;
      mov   eax,[edi];
      jz    @case_vtExtended;
     @else:
      push  eax;
      test  ecx,ecx;
      jnz   @push_loop;
      jmp   @call_original;
     @case_vtExtended:
      fld   tbyte ptr [eax];
      sub   esp,8;
      fstp  qword ptr [esp];
      inc   Argc;
      test  ecx,ecx;
      jnz   @push_loop;
     @call_original:
      mov   eax,fmt;
      call  system.@LStrToPChar;
      push  eax;
      call  _gmp_printf;
      mov   Result,eax;
      mov   ecx,Argc;
      lea   ecx,[ecx*4+4];
      add   esp,ecx;
      pop   edi;
    end;
end;

function gmp_sprintf(buf: PChar; const fmt: String; const Args: array of const): Integer;
var
  Argc: Integer;
begin
    Argc := length(Args);
    asm
      push  edi;
      mov   ecx,Argc;
      test  ecx,ecx;
      jz    @call_original;
     @push_loop:
      mov   edx,Args;
      dec   ecx;
      lea   edi,[edx+ecx*8];
      xor   eax,eax;
      mov   al,TVarRec[edi].VType;
      cmp   eax,vtExtended;
      mov   eax,[edi];
      jz    @case_vtExtended;
     @else:
      push  eax;
      test  ecx,ecx;
      jnz   @push_loop;
      jmp   @call_original;
     @case_vtExtended:
      fld   tbyte ptr [eax];
      sub   esp,8;
      fstp  qword ptr [esp];
      inc   Argc;
      test  ecx,ecx;
      jnz   @push_loop;
     @call_original:
      mov   eax,fmt;
      call  system.@LStrToPChar;
      push  eax;
      push  buf;
      call  _gmp_sprintf;
      mov   Result,eax;
      mov   ecx,Argc;
      lea   ecx,[ecx*4+8];
      add   esp,ecx;
      pop   edi;
    end;
end;

function gmp_snprintf(buf: PChar; size: Integer; const fmt: String; const Args: array of const): Integer; overload;
var
  Argc: Integer;
begin
    Argc := length(Args);
    asm
      push  edi;
      mov   ecx,Argc;
      test  ecx,ecx;
      jz    @call_original;
     @push_loop:
      mov   edx,Args;
      dec   ecx;
      lea   edi,[edx+ecx*8];
      xor   eax,eax;
      mov   al,TVarRec[edi].VType;
      cmp   eax,vtExtended;
      mov   eax,[edi];
      jz    @case_vtExtended;
     @else:
      push  eax;
      test  ecx,ecx;
      jnz   @push_loop;
      jmp   @call_original;
     @case_vtExtended:
      fld   tbyte ptr [eax];
      sub   esp,8;
      fstp  qword ptr [esp];
      inc   Argc;
      test  ecx,ecx;
      jnz   @push_loop;
     @call_original:
      mov   eax,fmt;
      call  system.@LStrToPChar;
      push  eax;
      push  size;
      push  buf;
      call  _gmp_snprintf;
      mov   Result,eax;
      mov   ecx,Argc;
      lea   ecx,[ecx*4+12];
      add   esp,ecx;
      pop   edi;
    end;
end;

function gmp_snprintf(var buf: String; const fmt: String; const Args: array of const): Integer; overload;
begin
    Result := gmp_snprintf(PChar(buf),length(buf),fmt,Args);
    if Result < length(buf) then
      SetLength(buf,Result);
end;

function gmp_scanf(const fmt: String; const Args: array of Pointer): Integer;
var
  Argc: Integer;
begin
    Argc := length(Args);
    asm
      mov   ecx,Argc;
      test  ecx,ecx;
      jz    @call_original;
     @push_loop:
      mov   edx,Args;
      dec   ecx;
      mov   eax,[edx+ecx*4];
      push  eax;
      jnz   @push_loop;
     @call_original:
      mov   eax,fmt;
      call  system.@LStrToPChar;
      push  eax;
      call  _gmp_scanf;
      mov   Result,eax;
      mov   ecx,Argc;
      lea   ecx,[ecx*4+4];
      add   esp,ecx;
    end;
end;

function gmp_sscanf(const s: String; const fmt: String; const Args: array of Pointer): Integer;
var
  Argc: Integer;
begin
    Argc := length(Args);
    asm
      mov   ecx,Argc;
      test  ecx,ecx;
      jz    @call_original;
     @push_loop:
      mov   edx,Args;
      dec   ecx;
      mov   eax,[edx+ecx*4];
      push  eax;
      jnz   @push_loop;
     @call_original:
      mov   eax,fmt;
      call  system.@LStrToPChar;
      push  eax;
      mov   eax,s;
      call  system.@LStrToPChar;
      push  eax;
      call  _gmp_sscanf;
      mov   Result,eax;
      mov   ecx,Argc;
      lea   ecx,[ecx*4+8];
      add   esp,ecx;
    end;
end;


{
/* Using "&" rather than "&&" means these can come out branch-free.  Every
   mpz_t has at least one limb allocated, so fetching the low limb is always
   allowed.  */
#define mpz_odd_p(z)   (((z)->_mp_size != 0) & __GMP_CAST (int, (z)->_mp_d[0]))
#define mpz_even_p(z)  (! mpz_odd_p (z))
}
function mpz_odd_p(const op: mpz_t): Boolean;
begin
    Result := (op._mp_size <> 0) and ((op._mp_d^ and 1) <> 0);
end;

function mpz_even_p(const op: mpz_t): Boolean;
begin
    Result := (op._mp_size <> 0) and ((op._mp_d^ and 1) = 0);
end;

{
/* Allow faster testing for negative, zero, and positive.  */
#define mpz_sgn(Z) ((Z)->_mp_size < 0 ? -1 : (Z)->_mp_size > 0)
#define mpf_sgn(F) ((F)->_mp_size < 0 ? -1 : (F)->_mp_size > 0)
#define mpq_sgn(Q) ((Q)->_mp_num._mp_size < 0 ? -1 : (Q)->_mp_num._mp_size > 0)
}
function mpz_sgn(const op: mpz_t): Integer;
begin
    if op._mp_size > 0 then
      Result := 1
    else if op._mp_size < 0 then
      Result := -1
    else
      Result := 0;
end;

function mpf_sgn(const op: mpf_t): Integer;
begin
    if op._mp_size > 0 then
      Result := 1
    else if op._mp_size < 0 then
      Result := -1
    else
      Result := 0;
end;

function mpq_sgn(const op: mpq_t): Integer;
begin
    if op._mp_num._mp_size > 0 then
      Result := 1
    else if op._mp_num._mp_size < 0 then
      Result := -1
    else
      Result := 0;
end;

end.
